SystemOrganization addCategory: #'Iliad-More-Formula'!

!BlockClosure methodsFor: '*Iliad-More-Formula' stamp: 'NicolasPetton 6/7/2011 17:28'!
asFormulaCondition
	^ILPluggableCondition new
		conditionBlock: self;
		yourself! !

ILBuildable subclass: #ILField
	instanceVariableNames: 'formula conditions errors customRows reader writer labelContents commentContents id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

ILField subclass: #ILAutocompleteIntputField
	instanceVariableNames: 'options fieldId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILAutocompleteIntputField methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 22:08'!
completerScript
	| str |
	str := WriteStream on: ''.
	str nextPutAll: 'jQuery(''#', fieldId , ''').autocomplete('.
	str nextPut: $[.
	self options do: [:each |
		str nextPutAll: '"' , each ,'"']
		separatedBy: [str nextPut: $,].
	str nextPutAll: '])'.
	^str contents
	! !

!ILAutocompleteIntputField methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 22:09'!
fieldContents
	^[:e |
		e input
			id: fieldId;
			value: (self value ifNil: ['']);
			action: [:val | self value: val].
		e script: self completerScript]! !

!ILAutocompleteIntputField methodsFor: 'initialization' stamp: 'StevenCostiou 1/16/2010 22:41'!
initialize 
	super initialize.
	fieldId := ILId new! !

!ILAutocompleteIntputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/15/2010 22:04'!
options
	^options ifNil: [#()]! !

!ILAutocompleteIntputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/15/2010 22:04'!
options: aCollection
	options := aCollection ! !

ILField subclass: #ILCheckboxField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILCheckboxField methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:48'!
fieldContents
	^[:e | 
		e checkbox
			checked: (self value ifNil: [false]);
			action: [:boolean | self value: boolean]]! !

ILField subclass: #ILDateInputField
	instanceVariableNames: 'yearsInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 15:34'!
day
	^self value dayOfMonth! !

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 12:29'!
day: anInteger
	self value: (Date
		newDay: anInteger
		month: self month
		year: self year)! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:14'!
days
	^1 to: 31! !

!ILDateInputField methodsFor: 'building' stamp: 'SA 10/13/2010 12:33'!
fieldContents
	^[:e | 
		e select build: [:select |
			self months do: [:each | 
				select option
					text: (Date nameOfMonth: each) greaseString;
					action: [self month: each];
					selected: (self month = each)]].
		e select build: [:select |
			self days do: [:each | 
				select option 
					text: each greaseString;
					action: [self day: each];
					selected: (self day = each)]].
		e select build: [:select | 
			self years do: [:each |
				select option
					text: each greaseString;
					action: [self year: each];
					selected: (self year = each)]]]! !

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 12:24'!
month
	^self value monthIndex! !

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 12:28'!
month: anInteger
	self value: (Date
		newDay: self day
		month: anInteger
		year: self year)! !

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 12:31'!
months
	^1 to: 12! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:26'!
value
	^super value ifNil: [Date today]! !

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 12:30'!
year
	^self value year! !

!ILDateInputField methodsFor: 'accessing' stamp: 'SA 10/13/2010 12:31'!
year: anInteger
	self value: (Date
		newDay: self day
		month:  self month
		year: anInteger)! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:15'!
years
	^self yearsInterval! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:05'!
yearsInterval
	^yearsInterval ifNil: [
		(Date today year - 20) to: (Date today year + 20)]! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:05'!
yearsInterval: anInterval
	yearsInterval := anInterval! !

!ILField class methodsFor: 'instance creation' stamp: 'sa 5/9/2010 12:33'!
on: aFormula selector: aSelector
	^self new
		on: aFormula
		selector: aSelector;
		yourself! !

!ILField methodsFor: 'conditions' stamp: 'sa 1/4/2010 15:26'!
addCondition: aCondition
	self conditions add: aCondition! !

!ILField methodsFor: 'conditions' stamp: 'NicolasPetton 6/7/2011 17:42'!
addCondition: aCondition labelled: aBlock
	self addCondition: (aCondition asFormulaCondition 
		labelBlock: aBlock;
		yourself)! !

!ILField methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 15:54'!
addRow: aBlock
	self customRows add: aBlock! !

!ILField methodsFor: 'building' stamp: 'sa 5/26/2010 14:44'!
build
	^ILHTMLBuilderElement new
		build: self tableRowContents;
		yourself! !

!ILField methodsFor: 'building' stamp: 'sa 5/26/2010 14:44'!
buildContents
	^ILHTMLBuilderElement new
		build: self tableRowContents;
		yourself! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:37'!
comment: aString
	self commentContents: [:e | e text: aString]! !

!ILField methodsFor: 'accessing' stamp: 'StevenCostiou 1/16/2010 21:48'!
commentContents 
	^commentContents
		! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:37'!
commentContents: aBlock
	commentContents := aBlock! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:24'!
conditions
	^conditions ifNil: [conditions := OrderedCollection new]! !

!ILField methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 15:54'!
customRows
	^customRows ifNil: [customRows := OrderedCollection new]! !

!ILField methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 15:57'!
customRowsContents
	^[:tbody |
		self customRows do: [:each |
			tbody tr build: [:tr | 
				tr td.
				tr td class: 'custom'; build: each]]]! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:39'!
errors
	^errors ifNil: [{}]! !

!ILField methodsFor: 'building' stamp: 'sa 1/4/2010 15:50'!
errorsContents
	^[:tbody |
		self errors notEmpty ifTrue: [
			tbody tr build: [:tr |
				tr td.
				tr td div
					class: 'errors';
					build: [:div |
						div text: self errors first]]]]! !

!ILField methodsFor: 'building' stamp: 'sa 1/4/2010 15:47'!
fieldContents
	self subclassResponsibility! !

!ILField methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 15:53'!
formula
	^formula! !

!ILField methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 15:54'!
formula: aFormula
	formula := aFormula! !

!ILField methodsFor: 'accessing' stamp: 'NicolasPetton 5/13/2011 16:45'!
id
	^id ifNil: [id := ILId new asString]! !

!ILField methodsFor: 'testing' stamp: 'StevenCostiou 1/20/2010 20:36'!
isMultipart 
	^false! !

!ILField methodsFor: 'testing' stamp: 'sa 1/4/2010 15:52'!
isValid
	^self errors isEmpty! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:22'!
label: aString
	self labelContents: [:e | e text: aString]! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:22'!
labelContents
	^labelContents! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:22'!
labelContents: aBlock
	labelContents := aBlock! !

!ILField methodsFor: 'private' stamp: 'SebastienAudier 3/21/2011 15:57'!
on: aFormula selector: aSelector
	reader ifNil: [reader := aSelector].
	writer ifNil: [writer := (aSelector, ':') asSymbol].
	labelContents ifNil: [self label: aSelector greaseString].
	self formula: aFormula! !

!ILField methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 15:53'!
postCopyTo: aContainer
	formula := aContainer formula! !

!ILField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:34'!
reader
	^reader! !

!ILField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:34'!
reader: aSymbol
	reader := aSymbol! !

!ILField methodsFor: 'building' stamp: 'NicolasPetton 5/13/2011 16:46'!
tableRowContents
	^[:tbody |
		tbody tr build: [:tr |
			tr 
				cssClass: 'field';
				id: self id.
			self isValid ifFalse: [
				tr cssClass: tr cssClass, ' error'].
			tr th
				build: self labelContents.
			tr td
				build: self fieldContents].
		self commentContents ifNotNil:[
			tbody tr build: [:tr | 
				tr td.
				tr td
					cssClass: 'comment';
					build: self commentContents]].
		tbody 
			build: self errorsContents;
			build: self customRowsContents]! !

!ILField methodsFor: 'actions' stamp: 'np 1/4/2010 18:35'!
validate
	errors := OrderedCollection new.
	self conditions do: [:each | 
		(each validate: self value) ifFalse: [
			self errors add: (each labelFor: self value)]]! !

!ILField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:36'!
value
	^formula proxy perform: self reader! !

!ILField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:38'!
value: anObject
	formula proxy
		perform: self writer
		with: anObject! !

!ILField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:35'!
writer
	^writer! !

!ILField methodsFor: 'accessing' stamp: 'sa 5/9/2010 12:35'!
writer: aSymbol
	writer := aSymbol! !

ILField subclass: #ILFileInputField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILFileInputField methodsFor: 'building' stamp: 'StevenCostiou 1/20/2010 20:42'!
fieldContents
	^[:e |
		(self value isNil or: [self value isString]) 
			ifTrue: [e build: self uploadContents]
			ifFalse: [e build: self fileContents]]! !

!ILFileInputField methodsFor: 'building' stamp: 'StevenCostiou 1/16/2010 22:39'!
fileContents
	^[:e |		
		e text: self value filename]! !

!ILFileInputField methodsFor: 'testing' stamp: 'StevenCostiou 1/20/2010 20:41'!
isMultipart 
	^true! !

!ILFileInputField methodsFor: 'building' stamp: 'sa 3/6/2010 12:49'!
uploadContents
	^[:e |
		e file action: [:val | self value: val]]! !

ILField subclass: #ILInputField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:50'!
fieldContents
	^[:e | 
		e input 
			value: (self value ifNil: ['']);
			action: [:val | self value: val]]! !

ILInputField subclass: #ILNumberInputField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILNumberInputField methodsFor: 'private' stamp: 'SebastienAudier 3/21/2011 16:41'!
convertToNumber: aString
	^(aString copyReplaceAll: ',' with: '.' ) asNumber! !

!ILNumberInputField methodsFor: 'building' stamp: 'SebastienAudier 3/23/2011 10:22'!
fieldContents
       ^[:e |
               e input
                       value: (self value ifNil: [''] ifNotNil: [self value greaseString]);
                       action: [:val |
                            (val isEmpty)
                                ifTrue: [ self value: nil ]
                                ifFalse: [ self value: (self convertToNumber: val)]]]! !

ILField subclass: #ILOptionField
	instanceVariableNames: 'options optionLabelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

ILOptionField subclass: #ILMultipleCheckboxField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILMultipleCheckboxField methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:40'!
fieldContents
	^[:e |
		self options do:[:each |
			e checkbox 
				checked: (self value includes: each);
				action: [:boolean | 
					boolean 
					ifTrue: [self add: each]
					ifFalse: [self remove: each]].
				e space.
				self optionLabelBlock value: e value: each]
			separatedBy: [e br]]! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 7/20/2010 13:12'!
add: anObject
	(self value includes: anObject) ifTrue: [^self].
	self value: ((OrderedCollection withAll: self value)
		add: anObject;
		yourself)! !

!ILOptionField methodsFor: 'defaults' stamp: 'SebastienAudier 3/21/2011 16:43'!
defaultOptionLabelBlock
	^[:e :option | 
		e text: (option isString
			ifTrue: [option]
			ifFalse: [option greaseString])]! !

!ILOptionField methodsFor: 'testing' stamp: 'StevenCostiou 1/24/2010 23:03'!
isMultiple
	^true! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:42'!
optionLabelBlock
	^optionLabelBlock ifNil: [self defaultOptionLabelBlock]! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:45'!
optionLabelBlock: aBlock
	optionLabelBlock := aBlock! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:48'!
options
	^options ifNil: [{}]! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:51'!
options: aCollection
	options := aCollection! !

!ILOptionField methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:46'!
options: aCollection labelContents: aBlock
	self options: aCollection.
	self optionLabelBlock: aBlock! !

!ILOptionField methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:45'!
options: aCollection labels: aBlock
	self 
		options: aCollection
		labelContents: [:e :option |
			e text: (aBlock value: option)]! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 6/16/2010 16:44'!
remove: anObject
	(self value includes: anObject) ifFalse: [^self].
		self value: (self value
			remove: anObject;
			yourself)! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 6/16/2010 16:42'!
value
	^(super value isNil and: [self isMultiple]) 
		ifTrue:[OrderedCollection new]
		ifFalse: [super value]! !

ILOptionField subclass: #ILSelectField
	instanceVariableNames: 'multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILSelectField methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:50'!
fieldContents
	^[:e | 
		e select build: [:select |
			self isMultiple ifTrue: [select beMultiple].
			self options do: [:each | 
				select option
					build:  [:option |
						option selected: (self isMultiple
							ifTrue: [self value includes: each]
							ifFalse: [self value = each]).
						self optionLabelBlock value: option value: each.
						option action: [self isMultiple
							ifFalse: [self value: each]
						ifTrue: [self add: each]]]]]]! !

!ILSelectField methodsFor: 'testing' stamp: 'StevenCostiou 1/24/2010 23:08'!
isMultiple
	^self multiple! !

!ILSelectField methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 17:50'!
multiple
	^multiple ifNil: [false]! !

!ILSelectField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:54'!
multiple: aBoolean
	multiple := aBoolean! !

ILField subclass: #ILPasswordField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILPasswordField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:32'!
fieldContents
	^[:e | 
		e password
			value: (self value ifNil: ['']);
			action: [:val | self value: val]]	! !

ILField subclass: #ILRepeatedPasswordField
	instanceVariableNames: 'repeatedValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILRepeatedPasswordField methodsFor: 'accessing' stamp: 'NicolasPetton 4/26/2011 14:07'!
fieldContents
	^[:e | 
		e password
			value: (self value ifNil: ['']);
			action: [:val | self value: val].
		e password
			value: (self repeatedValue ifNil: ['']);
			action: [:val | self repeatedValue: val]]	! !

!ILRepeatedPasswordField methodsFor: 'accessing' stamp: 'NicolasPetton 4/26/2011 14:07'!
repeatedValue 
	^repeatedValue ! !

!ILRepeatedPasswordField methodsFor: 'accessing' stamp: 'NicolasPetton 4/26/2011 14:07'!
repeatedValue: aString 
	repeatedValue := aString! !

!ILRepeatedPasswordField methodsFor: 'actions' stamp: 'NicolasPetton 4/26/2011 14:11'!
validate
	super validate. 
	self repeatedValue = self value ifFalse: [
		self errors add: 'Values do not match']! !

ILField subclass: #ILTextareaField
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILTextareaField methodsFor: 'building' stamp: 'sa 1/4/2010 17:38'!
fieldContents
	^[:e | 
		e textarea build: [:textarea |
			self size ifNotNil: [
				textarea
					cols: self size x;
					rows: self size y].
			textarea
				text: (self value ifNil: ['']);
				action: [:val | self value: val]]]! !

!ILTextareaField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:34'!
size
	^size! !

!ILTextareaField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:34'!
size: aPoint
	size := aPoint! !

ILField subclass: #ILTimeInputField
	instanceVariableNames: 'hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILTimeInputField methodsFor: 'building' stamp: 'np 4/5/2010 17:42'!
fieldContents
	^[:e | 
		e select build: [:select | 
			(1 to: 24) do: [:each | 
				select option 
					text: each greaseString;
					action: [self hours: each];
					selected: self hours = each]].
		e select build: [:select | 
			(1 to: 60) do: [:each | 
				select option 
					text: each greaseString;	
					action: [self minutes: each];
					selected: self minutes = each]].
		e select build: [:select | 
			(1 to: 60) do: [:each | 
				select option 
					text: each greaseString;	
					action: [self seconds: each];
					selected: self seconds = each]].
		e input beHidden
			action: [:val | self value: self time]]! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:08'!
hours
	^hours! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:10'!
hours: anInteger
	hours := anInteger! !

!ILTimeInputField methodsFor: 'initialization' stamp: 'StevenCostiou 1/5/2010 17:10'!
initialize
	super initialize.
	self value: Time now! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:09'!
minutes
	^minutes! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:10'!
minutes: anInteger
	minutes := anInteger! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:09'!
seconds
	^seconds! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:10'!
seconds: anInteger
	seconds := anInteger! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:09'!
time
	^Time 
		hour: self hours
		minute: self minutes
		second: self seconds! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:27'!
time: aTime 
	self hours: aTime hours.
	self minutes: aTime minutes.
	self seconds: aTime seconds! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:12'!
value: aTime 
	super value: aTime.
	self time: aTime! !

Object subclass: #ILCondition
	instanceVariableNames: 'labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILCondition methodsFor: 'converting' stamp: 'NicolasPetton 6/7/2011 17:49'!
asFormulaCondition! !

!ILCondition methodsFor: 'defaults' stamp: 'NicolasPetton 6/7/2011 18:07'!
defaultLabelFor: anObject
	^'Condition failed'  ! !

!ILCondition methodsFor: 'accessing' stamp: 'NicolasPetton 6/7/2011 17:30'!
labelBlock
	^labelBlock! !

!ILCondition methodsFor: 'accessing' stamp: 'NicolasPetton 6/7/2011 17:30'!
labelBlock: aBlock
	labelBlock := aBlock! !

!ILCondition methodsFor: 'validating' stamp: 'NicolasPetton 6/7/2011 18:07'!
labelFor: anObject
	^self labelBlock 
		ifNil: [self defaultLabelFor: anObject]
		ifNotNil: [self labelBlock value: anObject]! !

!ILCondition methodsFor: 'validating' stamp: 'NicolasPetton 6/7/2011 17:30'!
validate: anObject
	"Override in subclasses.
	Validate in all cases by default"
	^true! !

ILCondition subclass: #ILEmailAddressCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILEmailAddressCondition methodsFor: 'defaults' stamp: 'NicolasPetton 6/7/2011 18:08'!
defaultLabelFor: anObject
	^'Invalid email address'  ! !

!ILEmailAddressCondition methodsFor: 'validating' stamp: 'NicolasPetton 6/7/2011 17:34'!
validate: anObject
	^anObject isString and: [anObject matchesRegex: '^.*\@.*\..*$']! !

ILCondition subclass: #ILNotEmptyCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILNotEmptyCondition methodsFor: 'defaults' stamp: 'NicolasPetton 6/7/2011 18:08'!
defaultLabelFor: anObject
	^'This field is required'  ! !

!ILNotEmptyCondition methodsFor: 'validating' stamp: 'NicolasPetton 6/7/2011 17:52'!
validate: anObject
	^anObject notNil and: [anObject notEmpty]! !

ILCondition subclass: #ILPluggableCondition
	instanceVariableNames: 'conditionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILPluggableCondition methodsFor: 'accessing' stamp: 'np 1/4/2010 18:31'!
conditionBlock
	^conditionBlock! !

!ILPluggableCondition methodsFor: 'accessing' stamp: 'np 1/4/2010 18:31'!
conditionBlock: aBlock
	conditionBlock := aBlock! !

!ILPluggableCondition methodsFor: 'validating' stamp: 'np 1/4/2010 18:31'!
validate: anObject
	^self conditionBlock value: anObject! !

ILWidget subclass: #ILFieldContainer
	instanceVariableNames: 'fields label formula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILFieldContainer class methodsFor: 'instance creation' stamp: 'SebastienAudier 3/21/2011 15:59'!
on: aFormula label: aString
	^self new
		formula: aFormula;
		label: aString;
		yourself! !

!ILFieldContainer methodsFor: 'adding' stamp: 'SebastienAudier 3/21/2011 16:03'!
addField: aField
	^self fields add: aField! !

!ILFieldContainer methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:07'!
contents
	^[:e | | root |
		root := self useFieldset
			ifTrue: [
				(e fieldset legend: self label) div class: 'fields']
			ifFalse: [e div class: 'fields'].
		root build: self tableContents]! !

!ILFieldContainer methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:03'!
fields 
	^fields ifNil: [fields := OrderedCollection new]! !

!ILFieldContainer methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:02'!
formula
	^formula! !

!ILFieldContainer methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:02'!
formula: aFormula
	formula := aFormula! !

!ILFieldContainer methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:02'!
label 
	^label ifNil: ['']! !

!ILFieldContainer methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:02'!
label: aString
	label := aString! !

!ILFieldContainer methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 16:01'!
postCopyTo: aFormula
	self formula: aFormula.
	fields := self fields collect: [:each | 
		each copy postCopyTo: self; yourself]! !

!ILFieldContainer methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:04'!
setFields: aCollection
	fields := aCollection! !

!ILFieldContainer methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:08'!
tableContents
	^[:e |
		e table tbody build: [:tbody |
				self fields do: [:each |
					tbody build: each]]]! !

!ILFieldContainer methodsFor: 'testing' stamp: 'SebastienAudier 3/21/2011 16:08'!
useFieldset
	^self label notEmpty! !

ILWidget subclass: #ILFormula
	instanceVariableNames: 'proxy conditions containers formulas buttons saveAction cancelAction errors multipart subFormula cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILFormula class methodsFor: 'instance creation' stamp: 'sa 1/4/2010 16:18'!
on: anObject
	^self new
		setModel: anObject;
		yourself! !

!ILFormula methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:34'!
SubFormulaContents
	^self containersContents! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 5/9/2010 14:04'!
addCondition: aCondition
	self conditions add: aCondition! !

!ILFormula methodsFor: 'accessing' stamp: 'NicolasPetton 6/7/2011 17:42'!
addCondition: aCondition labelled: aBlock
	self addCondition: (aCondition asFormulaCondition 
		labelBlock: aBlock;
		yourself)! !

!ILFormula methodsFor: 'accessing' stamp: 'NicolasPetton 4/26/2011 14:51'!
addCssClass: aString
	self cssClass: self cssClass, ' ', aString! !

!ILFormula methodsFor: 'adding' stamp: 'SebastienAudier 3/21/2011 16:19'!
addField: aField
	| container |
	container := self containers isEmpty 
		ifTrue: [self newContainer]
		ifFalse: [self containers last].
	^container addField: aField! !

!ILFormula methodsFor: 'adding' stamp: 'SebastienAudier 3/21/2011 16:20'!
addFormula: aFormula
	aFormula beSubFormula.
	^self formulas add: aFormula! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:10'!
autoCompleteInputOn: aSelector
	^self addField: (ILAutocompleteIntputField on: self selector: aSelector)! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 7/15/2010 13:47'!
beMultipart
	multipart := true! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:17'!
beSubFormula
	subFormula := true! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:19'!
buttons
	^buttons ifNil: [self defaultButtons]! !

!ILFormula methodsFor: 'accessing' stamp: 'StevenCostiou 1/20/2010 20:30'!
buttons: aCollection
	buttons := aCollection ! !

!ILFormula methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:35'!
buttonsContents
	^[:e |
		self buttons do: [:each |
			e button
				text: each key;
				action: [self perform: each value]]] ! !

!ILFormula methodsFor: 'actions' stamp: 'sa 5/9/2010 14:16'!
cancel
	self cancelAction valueWithPossibleArgument: self model! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:51'!
cancelAction
	^cancelAction ifNil: [self defaultCancelAction]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:51'!
cancelAction: aBlock
	cancelAction := aBlock! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:08'!
checkboxOn: aSelector
	^self addField: (ILCheckboxField on: self selector: aSelector)! !

!ILFormula methodsFor: 'enumerating' stamp: 'SebastienAudier 3/21/2011 16:24'!
collect: aBlock
	| copy |
	copy := self copy.
	copy containers do: [:each |
		each setFields: (each fields collect: aBlock)].
	copy formulas: (copy formulas collect: [:each | each collect: aBlock]).
	^copy! !

!ILFormula methodsFor: 'actions' stamp: 'SebastienAudier 3/21/2011 16:36'!
commit
	self formulas do: [:each | each commit].
	proxy commit! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 5/9/2010 14:03'!
conditions
	^conditions ifNil: [conditions := OrderedCollection new]! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:11'!
containers 
	^containers ifNil: [containers := OrderedCollection new]! !

!ILFormula methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:35'!
containersContents
	^[:e |
		self containers do: [:each | 
			e build: each].
		self formulas do: [:each |
			e build: each]]! !

!ILFormula methodsFor: 'building' stamp: 'SebastienAudier 3/21/2011 16:33'!
contents
	^self isSubFormula
			ifFalse: [self mainFormulaContents]
			ifTrue: [self subFormulaContents]! !

!ILFormula methodsFor: 'accessing' stamp: 'NicolasPetton 4/26/2011 14:45'!
cssClass
	^cssClass ifNil: ['formula']! !

!ILFormula methodsFor: 'accessing' stamp: 'NicolasPetton 4/26/2011 14:46'!
cssClass: aString
	cssClass := aString! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:08'!
dateInputOn: aSelector
	^self addField: (ILDateInputField on: self selector: aSelector)! !

!ILFormula methodsFor: 'defaults' stamp: 'StevenCostiou 1/16/2010 20:41'!
defaultButtons
	^{'Save' -> #save. 'Cancel' -> #cancel}! !

!ILFormula methodsFor: 'defaults' stamp: 'sa 3/6/2010 12:53'!
defaultCancelAction
	^[:model | self answer: nil]! !

!ILFormula methodsFor: 'defaults' stamp: 'sa 8/4/2010 16:39'!
defaultSaveAction
	^[:model | self commit. self answer: self model]! !

!ILFormula methodsFor: 'enumerating' stamp: 'SebastienAudier 3/21/2011 16:20'!
do: aBlock
	self fields do: aBlock.
	self formulas do: aBlock! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 5/9/2010 14:04'!
errors
	^errors ifNil: [errors := OrderedCollection new]! !

!ILFormula methodsFor: 'building' stamp: 'sa 5/9/2010 14:14'!
errorsContents
	^[:e |
		self errors notEmpty ifTrue: [
			e ul
				class: 'errors';
				build: [:ul |
					self errors do: [:each |
						ul li text: each]]]]! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:16'!
fields
	| fields |
	fields := OrderedCollection new.
	self containers do: [:each | fields addAll: each fields].
	self formulas do: [:each | fields addAll: each fields].
	^fields! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:09'!
fileInputOn: aSelector
	^self addField: (ILFileInputField on: self selector: aSelector)! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:13'!
formulas
	^formulas ifNil: [formulas := OrderedCollection new]! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:13'!
formulas: aCollection
	formulas := aCollection! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:07'!
inputOn: aSelector
	^self addField: (ILInputField on: self selector: aSelector)! !

!ILFormula methodsFor: 'testing' stamp: 'StevenCostiou 1/16/2010 22:42'!
isEmpty
	^self fields isEmpty! !

!ILFormula methodsFor: 'testing' stamp: 'SebastienAudier 3/21/2011 16:38'!
isMultipart 
	^self multipart or: [
		((self fields addAll: self formulas; yourself) select: [:each | 
			each isMultipart]) notEmpty]! !

!ILFormula methodsFor: 'testing' stamp: 'SebastienAudier 3/21/2011 16:39'!
isSubFormula 
	^self subFormula! !

!ILFormula methodsFor: 'testing' stamp: 'SebastienAudier 3/21/2011 16:37'!
isValid
	self fields do: [:each |
		each isValid ifFalse: [^false]].
	self formulas do: [:each |
		each isValid ifFalse: [^false]].
	^self errors isEmpty! !

!ILFormula methodsFor: 'building' stamp: 'NicolasPetton 4/26/2011 14:46'!
mainFormulaContents
	^[:e | 
		e div 
			class: self cssClass;
			build: self errorsContents;
			build: [:div |
				div form build: [:form |
					form multipart: self isMultipart.
					form build: self containersContents.
					form div 
						class: 'buttons';
						build: self buttonsContents]]]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 5/9/2010 14:02'!
model
	^proxy model! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 7/15/2010 13:48'!
multipart
	^multipart ifNil: [false]! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:09'!
multipleCheckBoxOn: aSelector
	^self addField: (ILMultipleCheckboxField on: self selector: aSelector)! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:13'!
newContainer
	^self newContainerLabelled: ''! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:14'!
newContainerLabelled: aString
	^self containers add: (ILFieldContainer on: self label: aString)! !

!ILFormula methodsFor: 'adding' stamp: 'SA 10/13/2010 12:34'!
numberInputOn: aSelector
	^self addField: (ILNumberInputField on: self selector: aSelector)! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:08'!
passwordOn: aSelector
	^self addField: (ILPasswordField on: self selector: aSelector)! !

!ILFormula methodsFor: 'copying' stamp: 'SebastienAudier 3/21/2011 16:11'!
postCopy
	super postCopy.
	containers := self containers collect: [:each |
		each copy postCopyTo: self; yourself]	! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 5/9/2010 14:03'!
proxy
	^proxy! !

!ILFormula methodsFor: 'enumerating' stamp: 'SebastienAudier 3/21/2011 16:30'!
reject: aBlock
	| copy |
	copy := self copy.
	copy containers do: [:each |
		each setFields: (each fields reject: aBlock)].
	copy formulas: (copy formulas collect: [:each | each reject: aBlock]).
	^copy! !

!ILFormula methodsFor: 'adding' stamp: 'NicolasPetton 4/26/2011 14:09'!
repeatedPasswordOn: aSelector
	^self addField: (ILRepeatedPasswordField on: self selector: aSelector)! !

!ILFormula methodsFor: 'actions' stamp: 'sa 8/4/2010 16:40'!
save
	self
		validate;
		markDirty.
	self isValid ifTrue: [
		self saveAction valueWithPossibleArgument: self model]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:50'!
saveAction
	^saveAction ifNil: [self defaultSaveAction]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:50'!
saveAction: aBlock
		saveAction := aBlock! !

!ILFormula methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 21:58'!
scripts
	^{'/javascripts/jquery.autocomplete.js'}! !

!ILFormula methodsFor: 'enumerating' stamp: 'SebastienAudier 3/21/2011 16:28'!
select: aBlock
	| copy |
	copy := self copy.
	copy containers do: [:each |
		each setFields: (each fields select: aBlock)].
	copy formulas: (copy formulas collect: [:each | each select: aBlock]).
	^copy! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:09'!
selectOn: aSelector
	^self addField: (ILSelectField on: self selector: aSelector)! !

!ILFormula methodsFor: 'private' stamp: 'sa 5/9/2010 14:22'!
setModel: anObject
	proxy := ILModelProxy on: anObject! !

!ILFormula methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 21:58'!
styles
	^{'/stylesheets/jquery.autocomplete.css'}
	! !

!ILFormula methodsFor: 'accessing' stamp: 'SebastienAudier 3/21/2011 16:17'!
subFormula
	^subFormula ifNil: [false]! !

!ILFormula methodsFor: 'adding' stamp: 'sa 5/9/2010 14:07'!
textareaOn: aSelector
	^self addField: (ILTextareaField on: self selector: aSelector)! !

!ILFormula methodsFor: 'actions' stamp: 'SebastienAudier 3/21/2011 16:37'!
validate
	errors := OrderedCollection new.
	self fields do: [:each | each validate].
	self formulas do: [:each | each validate].
	self isValid ifTrue: [
		self conditions do: [:each |
			(each validate: self proxy) ifFalse: [
				self errors add: (each labelFor: self proxy)]]]! !
